var channel_here = "60dd7f55-9f88-4de6-ad98-b9c4e2810300";
var channel_main_1 = "rc1";
var channel_main_2 = "rc2";

var fahrplan = {};
var tweets = {};

/* === EXTERNAL DATA === */
function update_tweets() {
    var request = new XMLHttpRequest();
    request.open('GET', 'https://api.oct.re/tweets-rc3.json', true);
    request.onload = function() {
        if (this.status >= 200 && this.status < 400) {
            tweets = JSON.parse(this.response);
            update_tweet_ticker();
        } else { console.log(this); }
    };
    request.onerror = function(e) { console.log(e); };
    request.send();
}

function update_fahrplan() {
    var request = new XMLHttpRequest();
    request.open('GET', 'https://api.oct.re/fahrplan.json', true);
    request.onload = function() {
        if (this.status >= 200 && this.status < 400) {
            fahrplan = JSON.parse(this.response);
            update_fahrplan_html();
        } else { console.log(this); }
    };
    request.onerror = function(e) { console.log(e); };
    request.send();
}

/* === FAHRPLAN === */
var n_here = 3;
var n_main = 3;
var n_other = 7;

function parse_schedule() {
    var fahrplan_parsed = {
        "here": [],
        "main": [],
        "other": [],
    }
    
    for (var i in fahrplan) {
        if (fahrplan_parsed.here.length < n_here
            && (fahrplan[i].roomguid == channel_here || fahrplan[i].room == channel_here)) {
            fahrplan_parsed.here.push({
                title: fahrplan[i].title,
                sub: fahrplan[i].start + " D" + fahrplan[i].day + ", " + fahrplan[i].personnames,
            });
        } else if (fahrplan_parsed.main.length < n_main
                   && (fahrplan[i].roomguid == channel_main_1 || fahrplan[i].room == channel_main_1
                       || fahrplan[i].roomguid == channel_main_2 || fahrplan[i].room == channel_main_2)) {
            fahrplan_parsed.main.push({
                title: fahrplan[i].title,
                sub: fahrplan[i].start + " D" + fahrplan[i].day + " @ "  + fahrplan[i].room + ", " + fahrplan[i].personnames,
            });
        } else if (fahrplan_parsed.other.length < n_other) {
            fahrplan_parsed.other.push({
                title: fahrplan[i].title,
                sub: fahrplan[i].start + " D" + fahrplan[i].day + " @ " + fahrplan[i].room,
            });
        }
    }
    
    return fahrplan_parsed;
}

function update_fahrplan_html() {
    fahrplan_parsed = parse_schedule();
    var els = {
        here: document.getElementById("schedule-here"),
        main: document.getElementById("schedule-main"),
        other: document.getElementById("schedule-other"),
    }
    
    els.here.innerHTML = "";
    els.main.innerHTML = "";
    els.other.innerHTML = "";
    
    for (var group in els) {
        for (var i in fahrplan_parsed[group]) {
            var el = document.createElement("div");
            el.className = "item";
            
            var title = document.createElement("div");
            title.className = "title";
            title.innerText = fahrplan_parsed[group][i].title;
            el.appendChild(title);
            
            var sub = document.createElement("div");
            sub.className = "sub";
            sub.innerText = fahrplan_parsed[group][i].sub;
            el.appendChild(sub);
            
            els[group].appendChild(el);
        }
    }
}

update_fahrplan();


/* === TWEETS === */
function update_tweet_ticker() {
    var ticker = document.getElementById("ticker");
    ticker.innerHTML = "";
    for (var i in tweets.data) {
        //console.log(tweets.data[i].text);
        var item = document.createElement("div");
        item.className = "item";
        
        // Look up user
        var user;
        for (var useri in tweets.includes.users) {
            if (tweets.includes.users[useri].id == tweets.data[i].author_id)
                user = tweets.includes.users[useri];
        }
        
        var img = document.createElement("img");
        img.src = user.profile_image_url;
        item.appendChild(img);
        
        var user_el = document.createElement("span");
        user_el.className = "user";
        var uname = user.username;
        user_el.innerText = "@" + uname;
        item.appendChild(user_el);
        
        var content = document.createElement("span");
        content.className = "content";
        var text = tweets.data[i].text;
        text = text.replace(/\n/g, "↲");
        content.innerText = text;
        item.appendChild(content);
        
        ticker.appendChild(item);
    }
}

update_tweets();
